function LBP.ReadyCheck( self )


		local readycheck = LBP:CreateFrame("frame", "LBPReadyCheck", ReadyCheckFrame, nil, "TOP", ReadyCheckFrame, "BOTTOM", 0, -10, 315, 32)
			readycheck:SetBackdrop({bgFile = "Interface/BUTTONS/WHITE8X8", edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
			
			readycheck.list = {}	
		
		local _, _, _, numSpells = GetSpellTabInfo(1)
		local _, _, _, numSpells2 = GetSpellTabInfo(2)
		local a
		
		local n
		local start, duration, enable
		local name, rank, icon, powerCost, isFunnel, powerType, castingTime, minRange, maxRange = GetSpellInfo(a, "spell")
		local CD
		local tmpframe
		
		local zonetext = GetZoneText()
		local subzonetext = GetSubZoneText()
		local moonkin_direction
		local moonkin_power
		
		local opener = {[1] = "Solar opener", [2] = "Lunar opener", [3] = "Lunar opener at zero"}
		
	readycheck:SetScript("OnUpdate", function(self)
	
		readycheck:SetBackdropColor(abs(sin(GetTime()*100))*0.75, 0, 0 , 1)
		readycheck:ClearAllPoints()
		readycheck:SetPoint("TOP", ReadyCheckFrame, "BOTTOM", 0, 0)		
		
		n = 0;
		
		for a = numSpells+1, numSpells+numSpells2 do
			start, duration, enable = GetSpellCooldown(a, "spell")
	
			if duration < 2 then
				if readycheck.list[a] then readycheck.list[a]:Hide() end
			else
		
				readycheck:SetHeight(32)
			
				name, rank, icon, powerCost, isFunnel, powerType, castingTime, minRange, maxRange = GetSpellInfo(a, "spell")
				CD = math.ceil(duration-GetTime()+start);
		
		
				if not readycheck.list[a] then
					tmpframe = LBP:CreateFrame("frame", "LBPReadyCheck"..a, readycheck, nil, "TOPLEFT", readycheck, "TOPLEFT", 10, 0, 300, 48)
					tmpframe.icon = LBP:CreateFrame("frame", "LBPReadyCheckicon"..a, tmpframe, nil, "TOPLEFT", tmpframe, "TOPLEFT", 0, 0, 48, 48)
						tmpframe.icon:SetBackdrop({bgFile = icon });
					tmpframe.icontext = LBP:CreateFontString(tmpframe.icon, "icontext"..a,"ARTWORK", "GameFontNormalLarge", "TOPLEFT", tmpframe.icon, "TOPLEFT", 0, 0, 48, 48, "CENTER", "MIDDLE", 1, 1, 1, 1)
						tmpframe.icontext:SetText("B")
					tmpframe.textbox = LBP:CreateFontString(tmpframe.icon, "textbox"..a,"ARTWORK", "GameFontNormalLarge", "LEFT", tmpframe.icon, "RIGHT", 10, 0, 200, 48, "LEFT", "MIDDLE", 1, 1, 1, 1)
						tmpframe.textbox:SetText(name)
				
					function tmpframe.SetCD(self, CD)
						self.icontext:SetText(CD)
					end
			
					readycheck.list[a] = tmpframe
				end	
			
				;
		
				
					readycheck.list[a]:SetCD(CD)
					readycheck.list[a]:ClearAllPoints()
					readycheck.list[a]:SetPoint("TOPLEFT", readycheck, "TOPLEFT", 10, -n*54-10)
					readycheck.list[a]:Show()
				n = n+1;
			end
		end		
		
		-- Moonkin functions
		if GetSpecializationInfo(GetSpecialization()) == 102 then
		
			-- mushroom check
			if not readycheck.list["druid_mushrooms"] then
				tmpframe = LBP:CreateFrame("frame", "LBPReadyCheckdruid_mushrooms", readycheck, nil, "TOPLEFT", readycheck, "TOPLEFT", 10, 0, 300, 48)
				tmpframe.icon = LBP:CreateFrame("frame", "LBPReadyCheckicondruid_mushrooms", tmpframe, nil, "TOPLEFT", tmpframe, "TOPLEFT", 0, 0, 48, 48)
					tmpframe.icon:SetBackdrop({bgFile = "Interface/ICONS/druid_ability_wildmushroom_a" });
				tmpframe.icontext = LBP:CreateFontString(tmpframe.icon, "icontextdruid_mushrooms","ARTWORK", "GameFontNormalLarge", "TOPLEFT", tmpframe.icon, "TOPLEFT", 0, 0, 48, 48, "CENTER", "MIDDLE", 1, 1, 1, 1)
					--tmpframe.icontext:SetText("B")
				tmpframe.textbox = LBP:CreateFontString(tmpframe.icon, "textboxdruid_mushrooms","ARTWORK", "GameFontNormalLarge", "LEFT", tmpframe.icon, "RIGHT", 10, 0, 200, 48, "LEFT", "MIDDLE", 1, 1, 1, 1)
					tmpframe.textbox:SetText(name)
			
				function tmpframe.SetCD(self, CD)
					self.icontext:SetText(CD)
				end
				readycheck.list["druid_mushrooms"] = tmpframe
			end	
			
				
			if not GetTotemInfo(3) then
				readycheck.list["druid_mushrooms"].textbox:SetText("Erst zwei Pilze gesetzt")
				if not GetTotemInfo(2) then
					readycheck.list["druid_mushrooms"].textbox:SetText("Erst einen Pilz gesetzt")
				end
				if not GetTotemInfo(1) then
					readycheck.list["druid_mushrooms"].textbox:SetText("Noch keinen Pilz gesetzt")
				end				
				
					--readycheck.list["druid_mushrooms"]:SetCD(" ")
					
					readycheck.list["druid_mushrooms"]:ClearAllPoints()
					readycheck.list["druid_mushrooms"]:SetPoint("TOPLEFT", readycheck, "TOPLEFT", 10, -n*54-10)
					readycheck.list["druid_mushrooms"]:Show()
				n = n+1;
			else
				readycheck.list["druid_mushrooms"]:Hide()
			end
			
			
			-- eclipse start
			
			if not readycheck.list["druid_eclipse"] then
				tmpframe = LBP:CreateFrame("frame", "LBPReadyCheckdruid_eclipse", readycheck, nil, "TOPLEFT", readycheck, "TOPLEFT", 10, 0, 300, 48)
				tmpframe.lunar = LBP:CreateFrame("frame", "LBPReadyCheckicon", tmpframe, nil, "TOPLEFT", tmpframe, "TOPLEFT", 0, 0, 48, 48)
					tmpframe.lunar:SetBackdrop({bgFile = "Interface/ICONS/ability_druid_eclipse" });
					
				tmpframe.solar = LBP:CreateFrame("frame", "LBPReadyCheckicon", tmpframe, nil, "TOPRIGHT", tmpframe, "TOPRIGHT", -10, 0, 48, 48)
					tmpframe.solar:SetBackdrop({bgFile = "Interface/ICONS/ability_druid_eclipseorange" });
					
				tmpframe.textbox = LBP:CreateFontString(tmpframe, "textbox","ARTWORK", "GameFontNormalLarge", "LEFT", tmpframe.lunar, "RIGHT", 10, 0, 200, 48, "LEFT", "MIDDLE", 1, 1, 1, 1)
					tmpframe.textbox:SetText(name)


				readycheck.list["druid_eclipse"] = tmpframe
			end	
			
			zonetext = GetZoneText()
			subzonetext = GetSubZoneText()
			
			
			if LBP_DB[zonetext] then
				if LBP_DB[zonetext][subzonetext] then
					for index, value in pairs(LBP_DB[zonetext][subzonetext]) do
					
						
						if value["active"] then
							if value["moonkin_opener"] then
								readycheck.list["druid_eclipse"].textbox:SetText(opener[value["moonkin_opener"]].."\n"..GetEclipseDirection() .." ".. UnitPower("player", SPELL_POWER_ECLIPSE))

								readycheck.list["druid_eclipse"]:ClearAllPoints()
								readycheck.list["druid_eclipse"]:SetPoint("TOPLEFT", readycheck, "TOPLEFT", 10, -n*54-10)
								readycheck.list["druid_eclipse"]:Show()	
								
								if value["moonkin_opener"] == 1 then
									if GetEclipseDirection() == "moon" and UnitPower("player", SPELL_POWER_ECLIPSE) > 25 then
										readycheck.list["druid_eclipse"]:Hide()
									else
										n = n+1
									end
								elseif value["moonkin_opener"] == 2 then
									if GetEclipseDirection() == "moon" and UnitPower("player", SPELL_POWER_ECLIPSE) <= -70 then
										readycheck.list["druid_eclipse"]:Hide()
									else
										n = n+1
									end
								elseif value["moonkin_opener"] == 3 then
									if GetEclipseDirection() == "moon" and UnitPower("player", SPELL_POWER_ECLIPSE) == 0 then
										readycheck.list["druid_eclipse"]:Hide()
									else
										n = n+1
									end
								end
							end
						end
					end
				end
			end
				
					 --GetEclipseDirection()

			
			
		end
		
		readycheck:SetHeight(48+(n-1)*54+20)

		if n <1 then
			readycheck:ClearAllPoints()
			readycheck:SetPoint("TOP", ReadyCheckFrame, "BOTTOM", 0, 100000)
		end
		
	end)
	
	return readycheck
end



